%define _unpackaged_files_terminate_build 0
%define _pkidir		/etc/pki/CA
%define with_krb	0
Summary: Server daemons for IMAP and POP network mail protocols.
Summary(ko): IMAP 과 POP 프로토콜 서버 데몬
Name: imap
Version: 2007f
Release: 2%{?dist}
Epoch: 14
License: University of Washington Free-Fork License
Group: System Environment/Daemons
URL: http://www.washington.edu/imap/

Source: imap-%{version}.tar.gz
Source1: imap.pamd
Source2: make_imap_cert
Source3: imap-xinetd
Source4: ipop2-xinetd
Source5: ipop3-xinetd
Source6: imaps-xinetd
Source7: pop3s-xinetd
Source8: flock.c
Source9: README.IMAPS
# oops :
Source10: ssl_kr.txt
Source11: c-client.cf

Source100: ftp://ftp.cac.washington.edu/mail/imap-utils.tar.bz2

Patch0: imap-ssl-64.patch
Patch1: imap-ssl.patch
Patch2: imap-linux.patch
Patch3: imap-mbox-disable.patch
Patch4: imap-noask.patch
Patch5: imap-krbpath.patch
Patch6: imap-flock.patch
Patch7: imap-overflow.patch
Patch8: imap-time.patch
Patch9: imap-mail-spool-perms.patch
Patch10: imap-authmd5.patch
Patch11: imap-doc.patch
Patch12: imap-utils-makefiles.patch

# oops :
# 11 => change sub directory to mail
Patch100: imap-annyung-version.patch
Patch101: imap-annyung-goodbye.patch
Patch102: imap-annyung-subdir.patch
Patch103: imap-annyung-allowdnslookup.patch
Patch104: imap-annyung-default-charset.patch
Patch105: imap-annyung-disable-sslv23.patch

Buildroot: %{_tmppath}/%{name}-%{version}-root

BuildRequires: openssl-devel
%if %{with_krb}
BuildRequires: krb5-devel
%endif
# DO NOT REMOVE THIS PAM HEADER DEPENDANCY OR FACE THE WRATH
BuildRequires: /usr/include/security/pam_modules.h
Requires: pam >= 0.59
Conflicts: cyrus-imapd
Requires: %{_sysconfdir}/pam.d/system-auth
Requires: xinetd


%description
The imap package provides server daemons for both the IMAP (Internet
Message Access Protocol) and POP (Post Office Protocol) mail access
protocols.  The POP protocol uses a "post office" machine to collect
mail for users and allows users to download their mail to their local
machine for reading. The IMAP protocol allows a user to read mail on a
remote machine without downloading it to their local machine.

Install the imap package if you need a server to support the IMAP or
the POP mail access protocols.

%description -l ko
imap package 는 IMAP 프로토콜과 POP 프로토콜을 동시에 지원하는 서버 데몬
이다. POP 프로토콜은 사용자들이 서버에 저장이 되어 있는 메일들을 사용자
들의 로컬 HDD 로 다운받아 메일을 읽을 수 있도록 한다. IMAP 프로토콜은 사
용자들의 로컬 HDD 로 다운받을 필요 없이 원격에서 IMAP 서버로 접속을 하여
직접 메일을 읽을 수 있도록 한다.

%package devel
Summary: Development tools for programs which will use the IMAP library.
Summary(ko): Imap 라이브러리를 사용하여 프로그래밍을 하기 위한 개발 툴
Group: Development/Libraries

%description devel
The imap-devel package contains the header files and static libraries
for developing programs which will use the IMAP (Internet Message
Access Protocol) library.

%description devel -l ko
imap-devel 패키지는 IMAP 라이브러리를 사용하여 개발하는 프로그램들을 위
한 헤더 파일들과 정적 라이브러리들이 포함이 되어 있다.

%package doc
Summary: imap documents
Summary(ko): imap 문서
Group: Documentation
BuildArch: noarch

%description doc
imap-doc package include documents for IMAP package

%description doc -l ko
imap-doc 패키지는 imap 관련 문서들을 포함하고 있다.

%prep

%setup -q -a 100
chmod -R u+w .

%ifarch x86_64
%patch0 -p1
%else
%patch1 -p1
%endif
%patch2 -p1
%patch3 -p1
%if %{with_krb}
%patch4 -p1
%endif
%patch5 -p1
%patch6 -p1
%patch7 -p1
# Only apply the time.h patch to 7.x errata builds
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

# oops patch
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

cp %{SOURCE8} src/osdep/unix/
cp %{SOURCE9} .
# oops :
cp %{SOURCE10} .

%build
# Set EXTRACFLAGS here instead of in imap-2000-redhat.patch (#20760)
# oops : changed sub directory
EXTRACFLAGS="$EXTRACFLAGS -DDISABLE_POP_PROXY=1 -DIGNORE_LOCK_EACCES_ERRORS=1 -DMAILSUBDIR="mail""
EXTRACFLAGS="$EXTRACFLAGS -I/usr/include/openssl"
%if %{with_krb}
EXTRACFLAGS="$EXTRACFLAGS -I/usr/kerberos/include"
EXTRALDFLAGS="$EXTRALDFLAGS -L/usr/kerberos/lib"
%endif

make RPM_OPT_FLAGS="%{optflags} -fPIC -fno-omit-frame-pointer" lnp \
	EXTRACFLAGS="$EXTRACFLAGS" \
	EXTRALDFLAGS="$EXTRALDFLAGS" \
%if %{with_krb}
	EXTRAAUTHENTICATORS=gss \
%endif
	SSLTYPE=unix.nopwd \
# This line needs to be here.

# build imap-utils
pushd imap-utils &> /dev/null
for i in icat ifrom; do
  make -C $i
  pushd $i
  strip $i
  popd
done
popd

%install
rm -rf $RPM_BUILD_ROOT

# install man page
mkdir -p $RPM_BUILD_ROOT%{_mandir}/{man1,man8}
install -m0644 src/mailutil/mailutil.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -m0644 src/dmail/dmail.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -m0644 src/tmail/tmail.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -m0644 imap-utils/icat/icat.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -m0644 imap-utils/ifrom/ifrom.1 $RPM_BUILD_ROOT%{_mandir}/man1/
install -m0644 ./src/ipopd/ipopd.8 $RPM_BUILD_ROOT%{_mandir}/man8/ipopd.8
install -m0644 ./src/imapd/imapd.8 $RPM_BUILD_ROOT%{_mandir}/man8/imapd.8

# install Daemon
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
#install -s -m 755 ./ipopd/ipop2d $RPM_BUILD_ROOT%{_sbindir}
install -s -m 755 ./ipopd/ipop3d $RPM_BUILD_ROOT%{_sbindir}
install -s -m 755 ./imapd/imapd $RPM_BUILD_ROOT%{_sbindir}
# oops :
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sbindir}

# install utils
mkdir -p $RPM_BUILD_ROOT%{_bindir}
#install -m0755 chkmail/chkmail $RPM_BUILD_ROOT%{_bindir}/
install -m0755 dmail/dmail $RPM_BUILD_ROOT%{_bindir}/
install -m0755 mailutil/mailutil $RPM_BUILD_ROOT%{_bindir}/
install -m0755 mlock/mlock $RPM_BUILD_ROOT%{_bindir}/
install -m0755 imap-utils/icat/icat $RPM_BUILD_ROOT%{_bindir}/
install -m0755 imap-utils/ifrom/ifrom $RPM_BUILD_ROOT%{_bindir}/
install -m0755 tmail/tmail $RPM_BUILD_ROOT%{_bindir}/

# install pam files
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/etc/pam.d/imap
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/etc/pam.d/pop

## Install the shared lib
#install -m 755 libimap.so.%{version} $RPM_BUILD_ROOT%{_libdir}
#ln -sf libimap.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libimap.so

# isntall static library
mkdir -p $RPM_BUILD_ROOT%{_libdir}
install -m 644 ./c-client/c-client.a $RPM_BUILD_ROOT%{_libdir}/
ln -s c-client.a  $RPM_BUILD_ROOT%{_libdir}/libc-client.a

# install header
mkdir -p $RPM_BUILD_ROOT%{_includedir}/imap
install -m 644 ./c-client/*.h $RPM_BUILD_ROOT%{_includedir}/imap
# Added linkage.c to fix (#34658) <mharris>
install -m 644 ./c-client/linkage.c $RPM_BUILD_ROOT%{_includedir}/imap
install -m 644 ./src/osdep/tops-20/shortsym.h $RPM_BUILD_ROOT%{_includedir}/imap

#install service configuration files
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
install -m644 %{SOURCE3} $RPM_BUILD_ROOT/etc/xinetd.d/imap
#install -m644 %{SOURCE4} $RPM_BUILD_ROOT/etc/xinetd.d/ipop2
install -m644 %{SOURCE5} $RPM_BUILD_ROOT/etc/xinetd.d/ipop3
install -m644 %{SOURCE6} $RPM_BUILD_ROOT/etc/xinetd.d/imaps
install -m644 %{SOURCE7} $RPM_BUILD_ROOT/etc/xinetd.d/pop3s

# Generate ghost *.pem files
mkdir -p $RPM_BUILD_ROOT/%{_pkidir}/certs/imap
touch $RPM_BUILD_ROOT/%{_pkidir}/certs/imap/{imapd,ipop3d}.pem
chmod 600 $RPM_BUILD_ROOT/%{_pkidir}/certs/imap/{imapd,ipop3d}.pem

install -m644 %{SOURCE11} $RPM_BUILD_ROOT/etc/c-client.cf

%clean
rm -rf $RPM_BUILD_ROOT

%post
# This was 'if with_ssl' before, but due to packaging problems with older
# releases handling the logic, I changed it to only happen in 7.x instead
# If no cert, migrate stunnel.pem, or generate a new cert
pushd %{_pkidir}/certs/imap &> /dev/null || :
for CERT in imapd.pem ipop3d.pem ;do
   if [ ! -e $CERT ];then
      if [ -e stunnel.pem ];then
         cp stunnel.pem $CERT &> /dev/null || :
      elif [ -e Makefile ];then
         make $CERT << EOF &> /dev/null || :
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
      fi
   fi
done
popd &> /dev/null || :

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/c-client.cf
/etc/pam.d/imap
/etc/pam.d/pop
#/etc/xinetd.d/ipop2
#/etc/xinetd.d/ipop3
#/etc/xinetd.d/imap
#/etc/xinetd.d/imaps

%attr(0600,root,root) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_pkidir}/certs/imap/imapd.pem
%attr(0600,root,root) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_pkidir}/certs/imap/ipop3d.pem

%{_mandir}/man1/*.1*
%{_mandir}/man8/ipopd.8*
%{_mandir}/man8/imapd.8*
#attr(0755,root,root)	%{_sbindir}/ipop2d
%attr(0755,root,root)	%{_sbindir}/ipop3d
%attr(0755,root,root)	%{_sbindir}/imapd
%attr(0700,root,root)	%{_sbindir}/make_imap_cert

%attr(0755,root,root) %{_bindir}/dmail
%attr(0755,root,root) %{_bindir}/icat
%attr(0755,root,root) %{_bindir}/ifrom
%attr(0755,root,root) %{_bindir}/mlock
%attr(0755,root,root) %{_bindir}/mailutil
%attr(0755,root,root) %{_bindir}/tmail

%files devel
%defattr(-,root,root)
%doc docs/*
%{_includedir}/imap
#FIXME: is this c-client.a necessary?
%{_libdir}/c-client.a
%{_libdir}/libc-client.a

%files doc
%doc LICENSE.txt README README.IMAPS docs/RELNOTES docs/*.txt ssl_kr.txt
%doc docs/CONFIG docs/SSLBUILD

%changelog
* Sat Jan 28 2017 JoungKyun.Kim <http://oops.org> 14:2007f-2%{?dist}
- fixed the location of imapd/ipops certificate to /etc/pki/CA/certs/imap
- disable sslv2 and sslv3

* Sun Sep  2 2012 JoungKyun.Kim <http://oops.org> 14:2007f-1%{?dist}
- update 2007f

* Tue Mar  3 2009 JoungKyun.Kim <http://oops.org> 13:2007e-1
- update 2007e

* Thu Oct  8 2008 JoungKyun.Kim <http://oops.org> 12:2007b-1
- update 2007b
- add default_charset patch on imapd
- add -d option for allow dns lookup

* Thu Mar 15 2007 JoungKyun.Kim <http://oops.org> 10:2006f-1
- update 2006f

* Wed Feb  7 2007 JoungKyun.Kim <http://oops.org> 9:2006e-1
- update 2006e

* Wed Dec  7 2005 JoungKyun.Kim <http://oops.org> 8:2004g-1
- update 2004g
- fixed CAN-2005-0198
- fixed CAN-2005-2933: buffer overflow
- devided init file to imap-@servicename@ pacakge

* Sun May 15 2005 JoungKyun.Kim <http://oops.org> 7:2004d-1
- update 2004d

* Fri Feb 25 2005 JoungKyun.Kim <http://oops.org> 6:2004c1-1
- update 2004c1 for CAN-2005-0198 fix (CRAM-MD5 problem)
  http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2005-0198

* Wed Nov 10 2004 JoungKyun.Kim <http://oops.org> 5:2004a-1
- update 2004a
- added imap-utils

* Mon Sep 15 2003 JoungKyun.Kim <http://oops.org> 2002d-2,2
- added no dnslookup patch

* Wed Jun 23 2003 JoungKyun.Kim <http://oops.org> 2002d-1,1
- update 2002d

* Mon Mar  3 2003 JoungKyun.Kim <http://oops.org> 2001a-2kr
- rebuild under OOPS Linux 1.0

* Mon May 27 2002 JoungKyun.Kim <http://oops.org> 2001a-1kr
- update imap-2001a

* Sat Jul 21 2001 JoungKyun.Kim <http://oops.org>
- change mail home to ~/mail

* Fri Jul 20 2001 JoungKyun.Kim <http://oops.org>
- securit hole patch

* Sat Jun 16 2001 JoungKyun.Kim <http://oops.org>
- pop3's goodbye message changed annyung message
- added cert file maker
